@charset "utf-8";

$border-radius: 4px;
$border-width: 1px;
$outline-width: 3px;
$transition: 0.25s ease-in-out;
$line-height: 1.5;

@import "colors.scss";

// Light theme is the default
@import "light-theme";
@import "dark-theme";

:root:not([data-theme="dark"]) {
    @include light-theme;
}

// Override with dark theme if the agent prefers dark
@media only screen and (prefers-color-scheme: dark) {
    :root:not([data-theme="light"]) {
        @include dark-theme;
    }
}

// Override with dark theme in case the user configured it
html[data-theme="dark"] {
    @include dark-theme;
}


// @import "pico/pico.scss";
@import "highlight.scss";
@import "accordion.scss";
@import "button.scss";
@import "input.scss";
@import "tooltip.scss";
@import "table.scss";


// Border box and reset all margins
*, *::before, *::after {
    box-sizing: border-box; // 1
    margin: 0;
}

// 1. Add text decoration inheritance in all browsers (opinionated)
// 2. Add vertical alignment inheritance in all browsers (opinionated)
::before, ::after {
    text-decoration: inherit; // 1
    vertical-align: inherit; // 2
}

// 1. Correct the line height in all browsers
// 2. Prevent adjustments of font size after orientation changes in IE on Windows Phone and in iOS
// 3. Change the default tap highlight to be completely transparent in iOS
// 4. Use the default cursor in all browsers (opinionated)
// 5. Use a 4-space tab width in all browsers (opinionated)
// 6. Prevent adjustments of font size after orientation changes in IE on Windows Phone and in iOS
// 7. Prevent the header shadow from making the page horizontally scrollable
html {
    -webkit-text-size-adjust: 100%; // 2
    -webkit-tap-highlight-color: rgba(0, 0, 0, 0); // 3
    tab-size: 4; // 5
    -ms-text-size-adjust: 100%; // 6
    background-color: var(--background-color);
    color: var(--color);
    font-size: var(--font-size);
    font-weight: var(--font-weight);
    line-height: var(--line-height); // 1
    text-rendering: optimizeLegibility;
    cursor: default; // 4
    overflow-x: hidden; // 7
}

// Render the `main` element consistently in IE
main {
    display: block;
}

body {
    padding: 0;
    margin: 0;
    line-height: $line-height;
    min-height: 100vh;
    overflow-x: clip;
}

// Default font styling
body {
    font-family: system-ui, -apple-system, "Segoe UI", "Roboto", "Ubuntu",
    "Cantarell", "Noto Sans", sans-serif, "Apple Color Emoji", "Segoe UI Emoji",
    "Segoe UI Symbol", "Noto Color Emoji";
}

:root { 
    font-weight: 400;
    font-size: 16px;
}

// Calculate standard paddings and margins
:root {
    --pad1: calc(0.25 * var(--pad3));
    --pad2: calc(0.5 * var(--pad3));
    --pad3: 2vw;
    --pad3: calc(clamp(8px, 2vw, 16px));
    --pad4: calc(2 * var(--pad3));
    --pad5: calc(4 * var(--pad3));
    --pad6: calc(8 * var(--pad3));
    
    --mar1: calc(0.25 * var(--mar3));
    --mar2: calc(0.5 * var(--mar3));
    --mar3: 2vw;
    --mar3: calc(clamp(8px, 2vw, 32px));
    --mar4: calc(2 * var(--mar3));
    --mar5: calc(4 * var(--mar3));
}


// Rows & columns (spacers)

.rows1 > *:not(:last-child), section > .wrapper > *:not(:last-child) {
    margin-bottom: var(--mar1);
}

.rows2 > *:not(:last-child),
form:not(.buttons) > *:not(:last-child),
section > *:not(:last-child),
section > .wrapper > *:not(:last-child) {
    margin-bottom: var(--mar2);
}

.rows3 > *:not(:last-child) {
    margin-bottom: var(--mar3);
}

.rows4 > *:not(:last-child) {
    margin-bottom: var(--mar4);
}

.columns, .columns1, .columns2, .columns3, .columns4 {
    display: flex;
    gap: var(--mar3);
    align-items: start;
    & > * {
        flex: 1 1 0;
        min-width: 26%;
    }
    flex-wrap: wrap;
}
.columns1 { gap: var(--mar1); }
.columns2 { gap: var(--mar2); }
.columns4 { gap: var(--mar4); }

@media only screen and (max-width: 768px) {
    .columns {
        flex-direction: column;
        align-items: stretch;
        & > * {
            flex: none;
        }
    }
} 

.wrap2 {
    flex-wrap: wrap;
    & > * {
        flex-basis: 34%;
    }
}



@import "typography.scss";


audio, canvas, iframe, img, svg, video {
    display: block;
}

// Add the correct display in iOS 4-7
audio:not([controls]) {
    display: none;
    height: 0;
}

// Remove the border on iframes in all browsers (opinionated)
iframe {
    border-style: none;
}

// 1. Remove the border on images inside links in IE 10.
// 2. Responsive by default
img {
    max-width: 100%; // 2
    height: auto; // 2
    border-style: none; // 1
}

// Change the fill color to match the text color in all browsers (opinionated)
svg:not([fill]) {
    fill: currentColor;
}

// Hide the overflow in IE
svg:not(:root) {
    overflow: hidden;
}



// Code

/**
* Code
*/

// Reboot based on :
// - normalize.css v8.0.1 | MIT License | github.com/necolas/normalize.css
// - sanitize.css v12.0.1 | CC0 1.0 Universal | github.com/csstools/sanitize.css
// ––––––––––––––––––––

pre, code, kbd, samp {
    font-family: monospace;
    font-size: 0.875em;
}

code, kbd {
    display: inline-block;
    color: var(--code-color);
}

pre {
    -ms-overflow-style: scrollbar;
    overflow: auto;
    max-height: 66vh;
    display: block;
    background: var(--pre-background-color);
    color: var(--pre-color);
    padding: var(--pad3);
    line-height: var(--line-height);
    border-radius: $border-radius;
    white-space: pre;
    box-shadow: var(--pre-box-shadow);
    
    > code {
        color: inherit;
        background: transparent;
        display: block;
        padding: 0;
        font-weight: normal;
    }
}

.container {
    padding: var(--mar3);
    max-width: 1400px;
    margin: 0 auto;
}

.click-to-copy {
    cursor: pointer;
}






// Breadcrumbs
h1.toplevel {
    line-height: 100%;
}

@media only screen and (min-width: 800px) {
    h1.toplevel {
        display: flex;
        align-items: baseline;
        justify-content: space-between;
        line-height: inherit;
    }   
}

nav.breadcrumb {
    font-weight: normal;
    display: flex;
    justify-content: start;
    font-size: 1rem;
}

nav.breadcrumb a:not(:first-child)::before {
    content: '⮜';
    margin: 0 0.5em;
    font-weight: bold;
    color: var(--muted-color);
}



// Avatars

.avatar {
    max-width: 3rem;
    max-height: 3rem;
    border-radius: 10%;
    transition: transform 0.25s;
    box-shadow: 0 2px 6px #0008;
    position: relative;
}

nav .avatar {
    max-width: 2rem;
    max-height: 2rem;
}

.avatar.is-large {
    max-width: 200px;
    max-height: 200px;
}

.avatar.is-prefix {
    max-width: 1.5rem;
    max-height: 1.5rem;
    margin-right: 0.25rem;
    vertical-align: middle;
    display: inline;
}

h1 .avatar {
    display: inline-block;
    height: 1.2em;
    vertical-align: middle;
    margin: -0.5em 0 -0.4em 0;
}

img.avatar:hover {
    transform: scale(3,3);
    z-index: 999;
}

#avatarPicker input[type="file"] {
    width: 200px;
}


// Tabs

.tab-selectors {
    border-bottom: 2px solid $purple;
    display: flex;
    flex-wrap: wrap;
    gap: var(--pad2);
    
    > * {
        cursor: pointer;
        transition: $transition;
        border-bottom-left-radius: 0;
        border-bottom-right-radius: 0;
        border-top-left-radius: $border-radius;
        border-top-right-radius: $border-radius;
        padding: var(--pad1) var(--pad2);
    }
    > .is-active, > .is-active button {
        background-color: #{$purple};
        color: white;
    }
}


button.link-button {
    background: none;
    border: none;
    cursor: pointer;
    font: inherit;
    display: inline;
    width: unset;
}

button.link-button:hover,
button.link-button:focus {
    text-decoration: none;
}

// Tags & notifications

.tag {
    float: right;
    margin: 0 0 0.25em 0.5em;
    background-color: #{$green};
    color: white;
    font-weight: bold;
    font-size: 0.75rem;
    padding: 0em 0.5em;
    border-radius: 3px;
    min-width: 1em;
    min-height: 1em;
    position: relative;
    z-index: 1;
    box-shadow: 0 1px 6px black;
    overflow: hidden;
    white-space: nowrap;
    text-overflow: ellipsis;
}

.tag.no-float {
    float: none;
}

.tag.left {
    float: left;
    margin: 0 0.5em 0.25em 0;
}

.tag.is-info {
    background-color: #0083cf;
}

.tag.is-warning {
    background-color: #d17905;
}

.tag.is-ok {
    background-color: #02a107;
}

.tag.is-important {
    background-color: #{$purple};
}

.tag.endterm1 { background-color: #303d36; }
.tag.endterm2 { background-color: #3f6361; }
.tag.endterm3 { background-color: #348aa5; }
.tag.endterm4 { background-color: #5982CD; }
.tag.endterm5 { background-color: #7672C2; }
.tag.endterm6 { background-color: #8E5FB1; }
.tag.endterm7 { background-color: #A14B98; }
.tag.endterm8 { background-color: #E05B96; }

.tag.endterm_info {
    width: 20px;
    height: 20px;
    box-shadow: none;
    text-align: center;
    background-color: white;
    color: #{$green};
}

.notification, .admonition {
    border-left: var(--pad2) solid #{$green};
    border-radius: $border-radius;
    padding: var(--pad1) 0 var(--pad1) var(--pad2);
} // note!

.admonition > .admonition-title {
    float: left;
    margin: 0 0.5em 0 0;
    font-weight: bold;
    &::after {
        content: "!";
    }
}

// Paragraphs can render right of the admonition title. Other content goes underneath.
.admonition > *:not(p) {
    clear: left;
}

.notification.is-info, .admonition.hint, .admonition.tip {
    border-color: #0083cf;
}

.notification.is-warning, .admonition.danger, .admonition.caution, .admonition.error, .admonition.warning {
    border-color: #d17905;
}

.notification.is-important, .admonition.attention, .admonition.important {
    border-color: #{$purple};
}

.notification + .notification {
    margin-top: var(--mar2);
}

.translucent {
    opacity: 0.5;
}

.hidden {
    visibility: hidden;
}

.no-display {
    display: none;
}

.presence-avatar {
    position: relative;
    display: inline-block;
    margin-right: 0.5rem;
    &.away {
        opacity: 0.5;
    }
    &.away, &.today {
        color: inherit;
    }
}


// People cards

.people-cards {
    display: grid;
    grid-template-columns: 1fr 1fr 1fr 1fr;
    gap: var(--mar3);
    align-items: flex-start;
    @media (max-width: 1200px) {
        grid-template-columns: 1fr 1fr 1fr;
    }
    @media (max-width: 900px) {
        grid-template-columns: 1fr 1fr;
    }
    @media (max-width: 600px) {
        grid-template-columns: 1fr;
    }
    & > a, & > div {
        display: flex;
        gap: var(--mar2);
        p {
            margin: 0;
        }
        h4 {
            margin: 0;
            font-size: var(--font-size);
        }
        & > *:last-child {
            flex: 1;
        }
    }
}

.tv .people-cards {
    @media (min-width: 1500px) {
        grid-template-columns: 1fr 1fr 1fr 1fr 1fr;
    }
    @media (min-width: 1800px) {
        grid-template-columns: 1fr 1fr 1fr 1fr 1fr 1fr;
    }
}

.line-centered {
    display: flex;
    width: 100%;
    justify-content: center;
    align-items: center;
    text-align: center;
}

.line-centered:before,
.line-centered:after {
    content: '';
    border-top: 2px solid;
    margin: 0 16px 0 0;
    flex: 1 0 16px;
}

.line-centered:after {
    margin: 0 0 0 16px;
}

.faint {
    color: #8888;
}

.header-teacher-short-name {
    text-transform: capitalize;
}

.header-group-name.empty, .header-group-name.empty + .people,
.header-teacher-short-name.empty, .header-teacher-short-name.empty + .people {
    display: none;
}

.people {
    display: grid;
    gap: 32px;
    grid-template-columns: repeat(auto-fill, 140px);
    justify-content: space-between;
}

.person {
    position: relative;
    background-size: cover;
    border-radius: 10%;
    width: 140px;
    height: 140px;
    display: flex;
    border: 2px solid #888;
    box-shadow: var(--card-box-shadow);
    flex-direction: column;
    overflow: hidden;

    & > h3, & > .name {
        margin-top: 2px;
        text-align: center;
        text-shadow: black 0 0 4px;
        flex: 1;
        color: white;
        font-weight: bold;
    }
    & > .tags {
        display: flex;
        align-items: center;
        flex-wrap: wrap;
        margin: 6px;
        transition: opacity .5s .5s ease;
        & > .tag {
            margin: 4px 4px 0 0;
        }
    }
    &.away {
        box-shadow: $purple 0 0 12px;
        border-color: $purple;
    }
    &.online {
        box-shadow: $green 0 0 12px;
        border-color: $green;
    }

    .tag.blink {
        display: flex;
        justify-content: center;
        font-weight: bold;
        position: absolute;
        left: 0;
        top: 0;
        right: 0;
        z-index: 90;
        margin: 0;
        font-size: 115%;

        animation: fade 1s infinite;

        @keyframes fade {
            0% {
              opacity: 1;
            }
            50% {
              opacity: 0;
            }
            100% {
              opacity: 1;
            }
        }
    }
}

.recorder {
    position: absolute;
    z-index: 101;
    right: 5px;
    bottom: 5px;
    padding: var(--pad2);
    color: white;
    background-color: $purple;
    border-radius: 5px;
}

.recorder.running {
    background-color: $green;
}

.recording-reviewer {
    position: fixed;
    display: flex;
    flex-direction: column;
    align-items: stretch;
    justify-content: center;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    background-color: rgba(0, 0, 0, 0.8);
    z-index: 101; /* above header */
    gap: var(--mar2);
    padding: var(--mar2);

    .slider-box {
        input {
            width: 100%;
        }
    }

    img {
        object-fit: contain;
        border-radius: 5px;
        margin: 0 auto;
        height: 160px; /* flex-grow will provide the actual size */
        flex: 1 1;
    }

    .time-display {
        display: flex;
        justify-content: space-between;
        align-items: center;
        z-index: 104;

        span {
            color: white;
        }
    }
}


// Cards

script {
    display: none !important;
}

.people-cards > .card {
    min-width: 0;
    h3, p, div {
        white-space: nowrap;
        overflow: hidden;
    }
}

.card {
    // margin: var(--mar3) 0;
    padding: var(--pad3);
    box-shadow: var(--card-box-shadow);
    border: 1px solid var(--card-border-color);
    border-radius: $border-radius;
    display: block;

    > * {
        display: block;
        min-width: 0;
    }
    
    > header,
    > footer {
        margin-right: calc(var(--mar3) * -1);
        margin-left: calc(var(--mar3) * -1);
        padding: calc(var(--pad3) * 0.66)
        var(--pad3);
        background-color: var(--card-sectioning-background-color);
    }
    
    > header {
        margin-top: calc(var(--mar3) * -1);
        margin-bottom: var(--mar3);
        border-bottom: 1px solid var(--card-border-color);
    }
    
    > footer {
        margin-top: var(--mar3);
        margin-bottom: calc(var(--mar3) * -1);
        border-top: 1px solid var(--card-border-color);
    }

    // The last child of a card should not have margin
    & > *:last-child {
        margin-bottom: 0;
    }
}

.card .card {
    margin: 1em 0;
    padding: calc(var(--pad3) * 0.5);
    box-shadow: 0 0.2rem 0.4rem #0003;
}


// Header bar

body > header {
    padding: 0;
    user-select: none;
    font-size: calc(clamp(14px, 3vw, 20px));
    position: sticky;
    top: 0;
    z-index: 100;
    box-shadow: 0 0 24px #0008;
    .left {
        display: flex;
        flex-wrap: wrap;
        gap: var(--pad2);
        & > * {
            gap: var(--pad1);
            display: flex;
        }
        .page-title {
            flex-wrap: wrap;
            &::before {
                content: ' ➤ ';
            }
            & > *:not(:first-child)::before {
                content: ' ➤ ';
            }
        }    
    }
}

.dropdown-menu {
    display: none;
    position: absolute;
    z-index: 100;
    right: 0;
    margin: 0;
    padding: var(--pad2) 0;
}

.dropdown-menu > * {
    white-space: nowrap;
    display: block;
    padding: var(--pad2) var(--pad3);
    &:hover {
        background-color: #ffffff40;
    }
}

body.show-dropdown-menu .dropdown-menu {
    display: block;
}

.invert {
    background-color: $primary;
    color: white;
}

.invert a {
    color: white;
}

.invert a.current {
    color: #8affeb;
}

body > header nav {
    display: flex;
    justify-content: space-between;
    align-items: center;
    div {
        padding: 0;
        display: flex;
        gap: var(--mar2);
        align-items: center;
        & > * {
            display: inline-block;
        }
    }
    &.container {
        padding-top: var(--mar2);
        padding-bottom: var(--mar2);
    }
}




/**
* Accessibility & User interaction
*/


// Based on :
// - normalize.css v8.0.1 | MIT License | github.com/necolas/normalize.css
// - sanitize.css v12.0.1 | CC0 1.0 Universal | github.com/csstools/sanitize.css
// ––––––––––––––––––––

// Accessibility

// Change the cursor on control elements in all browsers (opinionated)
[aria-controls] {
    cursor: pointer;
}

// Change the cursor on disabled, not-editable, or otherwise inoperable elements in all browsers (opinionated)
[aria-disabled="true"],
[disabled] {
    cursor: not-allowed;
}

// Change the display on visually hidden accessible elements in all browsers (opinionated)
[aria-hidden="false"][hidden] {
    display: initial;
}

[aria-hidden="false"][hidden]:not(:focus) {
    clip: rect(0, 0, 0, 0);
    position: absolute;
}

// User interaction
// Remove the tapping delay in IE 10
a,
area,
button,
input,
label,
select,
summary,
textarea,
[tabindex] {
    -ms-touch-action: manipulation;
}

textarea {
    resize: none;
}



// Hr

// 1. Add the correct box sizing in Firefox
// 2. Show the overflow in Edge and IE
hr {
    box-sizing: content-box; // 1
    height: 0; // 1
    overflow: visible; // 2
    border: none;
    border-top: 1px solid var(--muted-border-color);
}


// For chartist

.ct-legend li {
    list-style: none;
    margin-top: 0;
}

.ct-label {
    color: var(--text) !important;
}


// Old CSS

.chained {
    display: block;
    position: relative;
}

.chained:not(:last-child) {
    margin-bottom: 1.6rem;
}

.chained + .chained::before {
    content: "▼";
    position: absolute;
    top: -26px;
    left: 0;
    right: 0;
    text-align: center;
    font-size: 1rem;
    font-weight: normal;
    font-style: normal;
    color: var(--color);
    opacity: 0.4;
}



.lesson {
    border-radius: $border-radius;
    // border: 1px solid #ccc;
    box-shadow: var(--card-box-shadow);
    border: 2px solid var(--card-border-color);
    padding: var(--pad3);
    cursor: pointer;
    color: inherit;
    display: block;
    
}

.lesson.startable {
    border: 2px solid $purple;
}

.lesson.almost_startable {
    border: 2px dashed $purple;
}

.lesson.passed {
    border: 2px solid $green;
}

.lesson.provided {
    border: 2px dotted $green;
}

.lesson.needs_grading, .lesson.needs_consent {
    border: 2px dashed $green;
}

.lesson.in_progress, .lesson.paused {
    background-color: $purple;
    color: #eee;
    h4 {
        color: white;
    }
    .tag {
        color: #444 !important;
        background-color: white;
    }
}

.lesson.paused {
    filter: blur(1.5px);
    opacity: 0.8;
}


.lesson-dep {
    text-align: center;
    & .done {
        text-decoration: line-through;
    }
    svg {
        display: inline-block;
        margin-left: 4px;
    }
}



.assignment {
    
    .stats {
        color: #888;
        margin: -0.5rem 0 0.5rem;
    }

    pre.asciinema-terminal {
        overflow-y: hidden;
        overflow-x: hidden;
        padding: 0;
        margin: 0;
        max-height: none;
    }

    .side:has(> .asciinema-player-wrapper) {
        float: none;
    }

    img, video {
        box-shadow: 0 3px 6px rgba(0,0,0,0.3);
        border-radius: 4px;
        max-width: 50%;
        max-height: 80%;
        margin-top: var(--mar1);
    }

    .code-container {
        position: relative;
    }
    
    .copy-btn {
        position: absolute;
        bottom: 0.6rem;
        right: 0.6rem;
        font-size: 0.9rem;
        font-weight: 400;
        display: inline-block;
        width: auto;
        padding: 0.1rem 0.3rem;
        background-color: transparent;
        color: $copy-code-btn;
        border-radius: 0.1875rem;
        cursor: pointer;
        z-index: 10;
        transition: background-color 0.3s ease;
    }
    
    
    .copy-btn:hover {
        background-color: $copy-code-btn-hover-bg;
    }
        
    
    .no-border {
        box-shadow: none;
        border-radius: 0;
    }
    
    wired-card, .side, img[src$='#side'] {
        // The latter selector means that Markdown `[My img](img.jpg#side)` will match
        max-width: 400px;
        clear: both;
        display: table;
        @media (min-width: 900px), print {
            float: right;
            margin-left: 8px;
        }
        margin-bottom: 8px;
        img,video {
            max-width: 100%;
        }
    }
    
    wired-card {
        line-height: 1.5em;
        
        .hor {
            display: flex;
            align-items: center;
        }
        .hor > * {
            margin-right: 10px;
        }
        .hor > *:last-child {
            margin-right: 0;
        }
        
        h1, h2, h3, h4, h5 {
            font-weight: bold;
        }
        h1 { font-size: 1.75rem; }
        h2 { font-size: 1.6rem; }
        h3 { font-size: 1.45rem; }
        h4 { font-size: 1.30rem; }
        h5 { font-size: 1.15rem; }
        
        table {
            width: inherit;
        }
    }
    
    wired-card, wired-card * {
        font-family: 'Gloria Hallelujah' !important;
    }
    
    wired-card wired-card {
        float: none;
    }
    
    wired-card > * {
        margin: 10px 10px 0 10px;
    }
    wired-card > *:last-child {
        margin-bottom: 10px;
    }
    
    wired-card small {
        display: block;
        font-size: 70%;
        font-weight: bold;
    }
    
    wired-card a {
        text-decoration: underline;
        display: block;
    }
    
    &::after {
        content: '';
        display: block;
        clear: both;
    }
}

.objective {
    // box-shadow: 0 0 4px #{transparentize($green, 0.5)};
    // border: 1px solid #80808050;
    // border-radius: $border-radius;
    // padding: var(--pad3);
    > .text {
        margin-bottom: var(--pad2);
        &::after {
            content: '';
            display: block;
            clear: both;
        }
        
        .completed-objective * {
            opacity: 0.5;
        }
    }
    

    > .rubric {
        flex: 0 0 300px;

        @media(min-width: 1200px) {
            display: flex;
            gap: var(--mar2);
            > label {
                flex: 1;
            }
            > textarea {
                flex: 2;
            }
            input[type=radio] {
                display: none;
            }
        }

        input {
            width: auto;
        }

        input[type=radio]:checked + * {
            color: $purple;
        }
        input {
            width: auto;
        }

        > label {
            display: block;
            border-radius: 4px;
            background-color: #80808018;
            padding: 0 var(--mar1);
            > em {
                font-weight: bold;
                font-style: normal;
            }
            &:has(input:not(:disabled)) {
                cursor: pointer;
            }
        }
        > label:has(input[type=radio]:hover) {
            background-color: #80808065;
        }
        > label input[type=radio]:checked + * {
            color: white;
        }
        > label:has(input[type=radio]:checked) {
            background-color: var(--secondary);
            color: white;
        }
        > label:has(input[type=radio]:checked).sufficient {
            background-color: var(--primary);
            color: white;
        }

        > label > p {
            display: inline;
        }
        @media(max-width: 1199px) {
            > label:not(:first-child) {
                margin-top: 0.5rem;
            }
        }
    }
    
}


.link {
    font-size: 1rem;
    // color: $link;
    cursor: pointer;
    font-weight: normal;
    display: inline-block;
}

a.link_preview {
    padding: 0;
    display: block;
    // position: relative;
    // box-shadow: 0 3px 6px rgba(0,0,0,0.3);
    // border-radius: $border-radius;
    display: flex;
    min-height: 5em;
    > .thumbnail {
        width: 10rem;
        background-size: cover;
        background-position: 50% 50%;
        background-color: #eee;
        max-height: 8em;
    }
    > .info {
        padding: 1rem;
        flex: 1;
        > h1 {
            font-size: 100%;
            font-weight: bold;
            margin-top: 0;
            margin-bottom: 0.5rem;
            // color: $link;
            border: none;
        }
        > p {
            color: var(--color);
        }
    }
}

.plantuml {
    &.light {
        display: var(--display-light);
    }
    &.dark {
        display: var(--display-dark);
    }
    margin-left: -10px !important;
    margin-right: -10px !important;
    box-shadow: none !important;
    max-width: 100% !important;
    max-height: none !important;
}


table.rubric-table {
    border-collapse: collapse;
    table-layout: fixed;
    width: 100%;
    margin: 1em 0;
    
    th, td {
        width: 15%;
    }
    
    th.noborder, td.noborder {
        border: 0;
    }
    
    th:first-child, td:first-child {
        width: 4rem;
    }
    
    th:nth-child(2), td:nth-child(2) {
        width: 25%;
    }
    
    th:nth-child(3), td:nth-child(3) {
        width: 4em;
    }
}

table.map-table {
    width: 100%;
    outline: var(--pad1) solid $green;
    margin: var(--pad1);
    border-radius: $border-radius;
    thead, tfoot, tr.highlight {
        background-color: $green;
        th, td {
            color: white;
            font-weight: normal;
        }
    }
    tr.failed {
        background-color: $purple;
    }
    tr.incomplete {
        background-color: #444;
    }
    th {
        font-weight: bold;
    }
    td, th {
        padding: 0.25rem 0.5rem;
        vertical-align: middle;
    }
    tbody {
        tr:not(:first-child) {
            border-top: 1px solid #eee;
        }
    }
    td:not(:first-child), th:not(:first-child) {
        max-width: 3.5rem;
        width: 3.5rem;
        text-align: right;
        overflow: hidden;
    }
    td.error, th.error {
        color: var(--accent-text);
    }

    details {        
        margin-bottom: 0;
        summary + * {
            margin-top: 0;
        }
    }
}

table.schedule {
    tbody {
        width: 100%;
        display: table;
    }
    td.present {
        color: var(--primary);
    }
    td.home_structural,
    td.unknown {
        color: var(--secondary);
    }
    td.absent_structural {
        color: gray;
    }
}

@media print {
    body {
        zoom: 0.55;
    }
    body > header {
        position: relative;
    }
    .assignment textarea, .assignment input, .buttons, *[aria-label="main navigation"], .left > a {
        display: none !important;
    }
    pre, .asciinema-player, .objective, .map-table {
        break-inside: avoid;
    }
    h1, h2, h3 {
        page-break-after: avoid;
    }
    .assignment .rubric {
        display: none;
    }
    .template-file pre {
        max-height: none;
    }
}
.template-file h1 {
    border: none;
    font-size: 1.35rem;
}



$ct-series-colors: (
#d70206,
#f05b4f,
#f4c63d,
#d17905,
#453d3f,
#59922b,
#0544d3,
#6b0392,
#f05b4f,
#dda458,
#eacf7d,
#86797d,
#b2c326,
#6188e2,
#a748ca
) !default;

.ct-legend {
    display: flex;
    margin-right: -10px;
    li {
        margin-right: 10px;
    }
    
    li:before {
        width: 12px;
        height: 12px;
        border: 3px solid transparent;
        border-radius: 2px;
        content: '';
        display: inline-block;
        margin-right: 2px;
    }
    
    li.inactive:before {
        background: transparent;
    }
    
    &.ct-legend-inside {
        position: absolute;
        top: 0;
        right: 0;
    }
    
    @for $i from 0 to length($ct-series-colors) {
        .ct-series-#{$i}:before {
            background-color: nth($ct-series-colors, $i + 1);
            border-color: nth($ct-series-colors, $i + 1);
        }
    }
}



.buttons {
    justify-content: flex-end;
    display: flex;
    align-items: center;
    flex-wrap: wrap;
    gap: var(--pad3);
    button, .button, a[role=button], input[type=button], input[type=submit], input[type=reset] {
        margin-bottom: 0 !important;
        width: auto;
        white-space: nowrap;
    }
    &.wide {
        & > form {
            flex: 1;
            & > * {
                width: 100% !important;
            }
        }    
        button, .button, a[role=button], input[type=button], input[type=submit], input[type=reset] {
            width: auto;
            flex: 1;
        }
    }
    &.left {
        justify-content: flex-start;
    }
    input[type="text"], input:not([type]), textarea {
        flex: 1;
    }
}

.add-button {
    background-color: var(--primary);
    border-color: var(--primary);
    background-image: var(--icon-plus);
    background-position: center;
    background-repeat: no-repeat;
    background-size: 0.75em auto;
    color: #fff;
}
.fab {
    position: fixed;
    display: flex;
    gap: var(--mar2);
    > a {
        color: white;
        background-color: $green;
        border-radius: 50% !important;
        font-weight: bold;
        width: 64px;
        height: 64px;
        margin: 0 !important;
        box-shadow: var(--card-box-shadow);
        display: flex;
        justify-content: center;
        align-items: center;
        
        > svg {
            width: 48px;
            height: 48px;
        }

        font-size: 48px !important;
    }
    right: var(--mar3);
    bottom: var(--mar3);
}

.inbox_needs_consent {
    background-color: #848;
}
.inbox_in_progress {
    background-color: #{$purple};
}
.inbox_awaiting_approval {
    background-color: #0083cf;
}

.subtitle, .title {
    display: block;
}

.navbar-menu.is-active svg {
    // color: $primary;
}


table.sortable th {
    cursor: pointer;
}


.asciinema-player svg {
    display: inline-block;
}

.alternative {
    color: $purple;
    font-style: italic;
    padding: 0 4px;
    border-radius: 8px;
    background-color: #8882;
    border-left: 1px solid $purple;
    border-right: 1px solid $purple;
}


// Company DB styling
.company {
    .company-header {
        display: flex;
        flex-direction: column;
        align-items: center;
        justify-content: space-evenly;
        .name {
            font-size: 150%;
        }
        .logo {
            flex-shrink: 1;
            max-width: 100%;
            max-height: 80%;
        }
    }

    .company-header.card {
        height: 132px;
    }

    .company-header.large {
        padding: var(--pad3);
        height: 160px;
        flex-direction: row;
        justify-content: center;
        gap: var(--pad3);
        .name {
            font-size: 250%;
        }
    }

    .company-info {
        padding-top: 0;
        display: flex;
        align-items: flex-start;
        gap: var(--mar2);
        overflow-wrap: break-word;
        & > * {
            flex: 1;
            min-width: 300px;
        }
        flex-wrap: wrap;
        p, table, td, tr, th, a {
            color: inherit;
            border-color: inherit;
        }
    }
}

.safari {
    .safari-day {
        border-radius: $border-radius;
        box-shadow: var(--card-box-shadow);
        border: 2px solid var(--card-border-color);
        padding: var(--pad3);
        cursor: pointer;
        color: inherit;
        position: relative;
        display: flex;
        justify-content: space-between;
        align-items: center;
    }

    .spots {
        display: flex;
        gap: var(--pad2);
        align-items: center;
    }

    .safari-status {
        width: fit-content;
        margin: 0;
        overflow: visible;
        font-family: inherit;
        text-transform: none;
        color: var(--primary-inverse);
        background-color: var(--primary);
        padding: var(--pad2) var(--pad3);
        border-radius: 4px;
        outline: none;
        font-size: 1rem;
        font-weight: bold;
        text-align: center;

        &.closed {
            background-color: #595555;
        }

        &.open {
            background-color: #0e832b;
        }
    
        &.pending {
            background-color: #ab5111;
        }
    }
}

.company-internships {
    ol {
        padding: 0;
        
        li {
            display: flex;
            flex-direction: column;

            border-bottom: gray solid 1px;
            padding: 10px 0;
            margin: 10px 0;

            div {
                display: flex;
                flex-direction: row;
                justify-content: space-between;
                align-items: center;
                margin-bottom: 10px;

                div {   
                    h2 {
                        margin-top: 0px;
                    }
                }

                input[type="submit"] {
                    margin-left: 10px;
                }
            }

            .dates {
                flex-direction: column;
                justify-content: start;
                align-items: flex-start;

                h3 {
                    margin-top: 7px;
                    margin-right: 5px;
                    padding-right: 30px;
                }
            }
        }
    }

    h2 {
        margin-left: 25px;
    }

    form {
        display: flex;

        input[type="submit"] {
            flex: 1;
        }
    }
}

.modal {
    position: fixed;
    z-index: 100;
    left: 0;
    top: 0;
    width: 100vw;
    height: 100vh;
    background-color: #000000a0;
}

.modal > .content {
    background-color: var(--background-color);
    color: var(--color);
    box-shadow: var(--color) 0px 0px 40px;
    border-radius: 5px;
    width: 90vw;
    min-width: 320px;
    max-width: 800px;
    margin: 5vw auto 0 auto;
    position: relative;

    & > .scrollable {
        padding: 20px;
        overflow-y: auto;
        max-height: 90vh;
    }
}

.modal > .content > .close::before {
    content: '✘';
}
.modal > .content > .close {
    cursor: pointer;
    position: absolute;
    background-color: var(--color);
    color: var(--background-color);
    border: 2px solid var(--background-color);
    border-radius: 50%;
    width: 24px;
    line-height: 24px;
    text-align: center;
    font-weight: bold;
    top: -5px;
    right: -5px;
}

.modal form.htmx-indicator {
    pointer-events: none;
    filter: grayscale(100%);
}


// Frontpage styling

.frontpage {
    margin-bottom: var(--mar3);

    .header_img {
        background-image: linear-gradient(#00000000, #00000050, #00000070), url("jungle.jpg");
        background-repeat: no-repeat;
        background-position: 50% 35%;
        background-size: cover;
        padding: 12% 0;
        display: flex;
        align-items: center;
        justify-content: center;
        box-shadow: 0px 0px 15px black;

        .headers {
            margin: var(--mar3);
            h2 {
                color: white;
                text-shadow: 0 0 10px black;
                font-size: 2em;
                margin: 0;
                line-height: 100%;
            }
            h1 {
                color: white;
                text-shadow: 0 0 20px black;
                font-size: 4em;
                border: none;
                margin: 0;
                line-height: 100%;
            }    
        }

    }

    .info {
        max-width: 1200px;
        margin: var(--mar3) auto;
        gap: var(--mar3);
        display: flex;

        div, a {
            flex: 1;
            border-radius: 10px;
        }

        .text {
            background-color: $green;
            display: flex;
            flex-direction: column;
            justify-content: center;
            align-items: center;

            h2 {
                color: white;
                font-size: 3em;
                text-align: center;
                line-height: 100%;
            }

            p {
                margin: 0 auto;
                text-align: center;
                color: white;
                padding-left: var(--pad5);
                padding-right: var(--pad5);
            
                a {
                    color: white;
                    text-decoration: underline;
                }
            }
        }

        .img {
            background-repeat: no-repeat;
            background-size: cover;
            min-height: 350px;
        }

        .code_img {
            background-image: linear-gradient(#00000010, #00000030, #00000050), url("code.jpg");
            background-position: 50% 35%;
        }

        .class_img {
            background-image: linear-gradient(#00000000, #00000030, #00000050), url("working.jpg");
            background-position: 50% 35%;
        }

        .open_source_img {
            background-image: url("gitlab.png");
            background-position: center;
        }
    }

    @media (max-width: 600px) {
        .header_img {
            .headers {
                h1 {
                    font-size: 2.5em;
                }    
            }

        }

        .info {
            flex-direction: column;
            margin: 0;
            height: 500px;
            width: 100%;
            padding: 0;
            gap: 0;

            div {
                border-radius: 0;
            }
            .text {
                padding: var(--pad3);
            }
            > * {
                margin: var(--mar3) 0 0 0;
            }

            &:nth-of-type(odd) {
                flex-direction: column-reverse;
            }
        }
    }
}

// Styling for attempts on user page
.latest_attempts {
    tr.needs_grading, tr.awaiting_approval, tr.needs_consent {
        color: $purple;
        font-weight: bold;
    }

    tr.awaiting_approval > td:first-child::before {
        content: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' height='20px' width='20px' fill='%23009c82' viewBox='0 0 24 24'%3E%3Cpath d='M4 2a2 2 0 0 0-2 2v12a2 2 0 0 0 2 2h4v3a1 1 0 0 0 1 1h.5c.25 0 .5-.1.7-.29L13.9 18H20a2 2 0 0 0 2-2V4a2 2 0 0 0-2-2zm0 2h16v12h-6.92L10 19.08V16H4zm8.19 1.5c-.89 0-1.6.18-2.14.54c-.55.36-.83.96-.78 1.65h1.97c0-.28.1-.49.26-.63c.2-.14.42-.21.69-.21c.31 0 .58.08.76.26c.18.17.27.39.27.69c0 .28-.08.53-.22.74c-.17.22-.38.4-.64.54c-.52.32-.86.6-1.07.84c-.19.24-.29.58-.29 1.08h2c0-.28.05-.5.14-.68c.09-.17.26-.32.52-.47c.46-.21.84-.49 1.13-.85c.29-.37.44-.76.44-1.2q0-1.05-.81-1.68c-.54-.41-1.29-.62-2.23-.62M11 12v2h2v-2z'/%3E%3C/svg%3E");
    }
    tr.waiting_recording > td:first-child::before {
        content: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' height='20px' width='20px' fill='%23009c82' viewBox='0 0 24 24'%3E%3Cpath d='M17 12c0 .54-.1 1.05-.26 1.54L15 11.78A3.06 3.06 0 0 0 12.22 9l-1.76-1.74c.49-.16 1-.26 1.54-.26c2.76 0 5 2.24 5 5M9.88 4h4.24l1.83 2H20v10.8l1.88 1.88c.08-.21.12-.44.12-.68V6c0-1.11-.89-2-2-2h-3.17L15 2H9L7.18 4L8.6 5.4zm12.23 17.46l-1.27 1.27L18.11 20H4a2 2 0 0 1-2-2V6c0-.58.25-1.1.65-1.46L1.11 3l1.28-1.27zM9 12c0 1.66 1.34 3 3 3c.33 0 .65-.07.94-.17l-3.77-3.77c-.1.3-.17.61-.17.94m7.11 6l-1.66-1.66c-.73.41-1.56.66-2.45.66c-2.76 0-5-2.24-5-5c0-.89.25-1.72.66-2.45L4.11 6H4v12z'/%3E%3C/svg%3E");
    }
    tr.in_progress > td:first-child::before {
        content: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' height='20px' width='20px' fill='%23009c82' viewBox='0 0 24 24'%3E%3Cpath d='M13.5 5.5c1.09 0 2-.92 2-2a2 2 0 0 0-2-2c-1.11 0-2 .88-2 2c0 1.08.89 2 2 2M9.89 19.38l1-4.38L13 17v6h2v-7.5l-2.11-2l.61-3A7.3 7.3 0 0 0 19 13v-2c-1.91 0-3.5-1-4.31-2.42l-1-1.58c-.4-.62-1-1-1.69-1c-.31 0-.5.08-.81.08L6 8.28V13h2V9.58l1.79-.7L8.19 17l-4.9-1l-.4 2z'/%3E%3C/svg%3E");
    }
    tr.needs_grading > td:first-child::before {
        content: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' height='20px' width='20px' fill='%23009c82' viewBox='0 0 24 24'%3E%3Cpath d='M14 10H3v2h11zm0-4H3v2h11zM3 16h7v-2H3zm18.5-4.5L23 13l-7 7l-4.5-4.5L13 14l3 3z'/%3E%3C/svg%3E");
    }
    tr.needs_consent > td:first-child::before {
        content: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' height='20px' width='20px' fill='%23009c82' viewBox='0 0 24 24'%3E%3Cpath d='M12 9a3 3 0 0 1 3 3a3 3 0 0 1-3 3a3 3 0 0 1-3-3a3 3 0 0 1 3-3m0-4.5c5 0 9.27 3.11 11 7.5c-1.73 4.39-6 7.5-11 7.5S2.73 16.39 1 12c1.73-4.39 6-7.5 11-7.5M3.18 12a9.821 9.821 0 0 0 17.64 0a9.821 9.821 0 0 0-17.64 0'/%3E%3C/svg%3E");
    }
    tr.paused > td:first-child::before {
        content: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' height='20px' width='20px' fill='%23009c82' viewBox='0 0 24 24'%3E%3Cpath d='M14 19h4V5h-4M6 19h4V5H6z'/%3E%3C/svg%3E");
    }
    tr.repair > td:first-child::before {
        content: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' height='20px' width='20px' fill='%23009c82' viewBox='0 0 24 24'%3E%3Cpath d='m16.06 13.09l5.63 5.59l-3.32 3.28l-5.59-5.59v-.92l2.36-2.36zm.91-2.53L16 9.6l-4.79 4.8v1.97L5.58 22L2.3 18.68l5.59-5.59h1.97l.78-.78L6.8 8.46H5.5L2.69 5.62L5.31 3l2.8 2.8v1.31L12 10.95l2.66-2.66l-.96-1.01L15 5.97h-2.66l-.65-.65L15 2l.66.66v2.66L16.97 4l3.28 3.28c1.09 1.1 1.09 2.89 0 3.98l-1.97-2.01z'/%3E%3C/svg%3E");
    }
    tr.not_graded > td:first-child::before {
        content: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' height='20px' width='20px' fill='%23009c82' viewBox='0 0 24 24'%3E%3Cpath d='m10 10.2l4-4l3.8 3.8l-4 4l-1.4-1.4L15 9.9l-.9-.9l-2.6 2.6zm10.7-4.6l-2.3-2.3c-.2-.2-.5-.3-.7-.3s-.5.1-.7.3l-1.8 1.8L19 8.9L20.7 7c.4-.3.4-1 0-1.4M19 21.7L17.7 23l-6.5-6.5L6.8 21H3v-3.8l4.5-4.5L1 6.3L2.3 5zm-9.2-6.6l-.9-.9L5 18.1v.9h.9z'/%3E%3C/svg%3E");
    }
    tr.failed > td:first-child::before {
        content: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' height='20px' width='20px' fill='%23009c82' viewBox='0 0 24 24'%3E%3Cpath d='M12 2c5.53 0 10 4.47 10 10s-4.47 10-10 10S2 17.53 2 12S6.47 2 12 2m3.59 5L12 10.59L8.41 7L7 8.41L10.59 12L7 15.59L8.41 17L12 13.41L15.59 17L17 15.59L13.41 12L17 8.41z'/%3E%3C/svg%3E");
    }
    tr.fraudulent > td:first-child::before{
        content: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' width='20px' height='20px' viewBox='0 0 256 256'%3E%3Cpath fill='%23b17300' d='M116 20v-8a12 12 0 0 1 24 0v8a12 12 0 0 1-24 0m84 36a12 12 0 0 0 8.49-3.51l8-8a12 12 0 1 0-17-17l-8 8A12 12 0 0 0 200 56M47.51 52.49a12 12 0 0 0 17-17l-8-8a12 12 0 0 0-17 17ZM236 176v24a20 20 0 0 1-20 20H40a20 20 0 0 1-20-20v-24a20 20 0 0 1 16-19.6V140a92 92 0 0 1 92-92h.71C179 48.38 220 90.1 220 141v15.4a20 20 0 0 1 16 19.6M60 140v16h136v-15c0-37.77-30.27-68.72-67.48-69H128a68 68 0 0 0-68 68m152 40H44v16h168Zm-75.6-66.72a28 28 0 0 1 18.32 18.32a12 12 0 0 0 22.9-7.2a52 52 0 0 0-34-34a12 12 0 0 0-7.2 22.9Z'/%3E%3C/svg%3E");
    }
    tr.passed > td:first-child::before {
        content: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' height='20px' width='20px' fill='%23009c82' viewBox='0 0 24 24'%3E%3Cpath d='M21 7L9 19l-5.5-5.5l1.41-1.41L9 16.17L19.59 5.59z'/%3E%3C/svg%3E");
    }
    tr.passed td:last-child {
        color: $green;
    }
    tr.repair > td:last-child, tr.failed > td:last-child {
        color: $purple;
    }
    tr.paused, tr.fraudulent {
        color: #b17300;
    }
}

// Aligns absence reason
[data-tooltip]:is(td) {
    display: revert;
}

// Styling for default_schedule on user page

label.default-schedule {
    display: flex;
    justify-content: space-between;
    align-items: center;
    span {
        flex: 0 0 15%;
    }
}

label.default-schedule .radio-options {
    display: flex;
    flex: 1;

    label {
        flex: 1;
    }

    label input {
        position: absolute;
        opacity: 0;
    }
    
    label span {
        flex: 1;
        display: block;
        border: $border-width solid var(--form-element-border-color);
        border-right: none;
        width: 100%;
        padding: 2px 4px;
        cursor: pointer;
        text-align: center;
    }
    label:first-child span {
        border-radius: $border-radius 0 0 $border-radius;
        border-right: none;
    }
    label:last-child span {
        border-radius: 0 $border-radius $border-radius 0;
        border-right: $border-width solid var(--form-element-border-color);
    }
    label input:checked + span {
        background-color: var(--primary);
        color: var(--primary-inverse);
        font-weight: bold;
    }
}

@keyframes spinner {
    to {transform: rotate(360deg);}
}
  
form.htmx-request {
    position: relative;
    pointer-events: none;
    & > * {
        filter: blur(2px);
    }

    &:before {
        content: '';
        box-sizing: border-box;
        position: absolute;
        top: 50%;
        left: 50%;
        width: 20px;
        height: 20px;
        margin-top: -10px;
        margin-left: -10px;
        border-radius: 50%;
        border: 2px solid #ccc;
        border-top-color: #000;
        animation: spinner .6s linear infinite;
      }
}

form small {
    opacity: 85%;
    display: block;
}

#logo-link {
    display: flex;
    align-items: center;
 
    svg.record.error {
        animation: blink 0.5s infinite;
    }
}

@keyframes blink {
    0%,100% { opacity: 0; }
    50% { opacity: 1; }
}


.module_ready h2, h2.module_ready {
    color: $green;
}

.module_future h2, h2.module_future, .module_ h2, h2.module_ {
    color: inherit;
}

.curriculum_scroll .columns.after_init_snap > div.collapsed {
    scroll-snap-align: start;
}

.curriculum_scroll {
    margin: 0 0;
    max-width: 100%;
  
    .columns {
        padding-top: 10px;
        overflow: auto;

        /* Hide scrollbar for Chrome, Safari and Opera */
        &::-webkit-scrollbar {
            display: none;
        }
  
        /* Hide scrollbar for IE, Edge and Firefox */
        -ms-overflow-style: none;  /* IE and Edge */
        scrollbar-width: none;  /* Firefox */

        display: grid;
        grid-auto-flow: column;
        gap: var(--mar3);
        scroll-snap-type: x mandatory;
        scroll-behavior: smooth;
        scroll-snap-stop: normal;
        outline: none;
        position: relative;

        label.period {
            position: absolute;
            top: -5px;
        }

        > div > *:nth-child(2) {
            margin-top: var(--mar2);
        }

        > div.collapsed {
            width: 30px;
            height: 400px;
            max-height: 85vw;
        }
    
        > div.uncollapsing {
            scroll-snap-align: start;
            width: 400px;
            max-width: 85vw;
        }
    
        > div.uncollapsed {
            scroll-snap-align: start;
            width: 400px;
            max-width: 85vw;
        }
    
        > div.collapsing {
            scroll-snap-align: start;
            width: 400px;
            max-width: 85vw;
        }
    
        > div {
            transition: margin 0.5s ease, width 0.5s ease;
        }

        .node-title {
            cursor: pointer;
        }

        .node-title + * {
            margin-top: var(--mar2);
        }
    
        .uncollapsing .node-title {
            margin-bottom: 100vh;
        }
    
        .uncollapsed .node-title {
            transition: margin 0.5s ease;
            margin-bottom: 0vh;
        }
    
        .collapsing .node-title > h2 {
            transform: rotate(90deg);
            transform-origin: left;
            transition: transform 0.5s ease, margin 0.5s;
            margin-top: -10px;
        }
    
        .collapsed .node-title > h2 {
            transform: rotate(90deg);
            transform-origin: left;
            width: 400px;
            margin-left: 20px;
            margin-top: -10px;
        }
    
        .uncollapsed .node-title > h2 {
            transform: rotate(0deg);
            transform-origin: left;
            transition: transform 0.5s ease, margin 0.5s ease;
        }
    
        .uncollapsing .node-title > h2 {
            transform: rotate(90deg);
            transform-origin: left;
            width: 400px;
            margin-left: 20px;
            margin-top: -10px;
        }
    
        .collapsed > :not(.node-title, label) {
            display: none;
        }
    
        .collapsing > .node-title {
            transition: margin 0.5s ease;
            margin-bottom: 100vh;
            margin-left: 20px;
        }
    
        .collapsed .tag.is-important {
            margin-right: 25px;
        }
    }
}

small.train {
    font-size: 16px;
    font-weight: normal;
    vertical-align: middle;
    display: inline-block;
    color: var(--color);
    opacity: 0.66;
    &::before {
        content: '';
        display: inline-block;
        width: 20px;
        height: 20px;
        margin-left: 4px;
        vertical-align: middle;
        --svg: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 24 24'%3E%3Cpath fill='%23000' d='M12 4c-3.51 0-4.96.48-5.57 1h11.13c-.6-.52-2.05-1-5.56-1M6 15.5c0 .83.67 1.5 1.5 1.5h9c.83 0 1.5-.67 1.5-1.5V12H6zm9.5-2.5c.83 0 1.5.67 1.5 1.5s-.67 1.5-1.5 1.5s-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5m-7 0c.83 0 1.5.67 1.5 1.5S9.33 16 8.5 16S7 15.33 7 14.5S7.67 13 8.5 13' opacity='.3'/%3E%3Ccircle cx='8.5' cy='14.5' r='1.5' fill='%23000'/%3E%3Ccircle cx='15.5' cy='14.5' r='1.5' fill='%23000'/%3E%3Cpath fill='%23000' d='M12 2c-4 0-8 .5-8 4v9.5C4 17.43 5.57 19 7.5 19L6 20.5v.5h2l2-2h4l2 2h2v-.5L16.5 19c1.93 0 3.5-1.57 3.5-3.5V6c0-3.5-4-4-8-4m0 2c3.51 0 4.96.48 5.57 1H6.43c.61-.52 2.06-1 5.57-1M6 7h5v3H6zm12 8.5c0 .83-.67 1.5-1.5 1.5h-9c-.83 0-1.5-.67-1.5-1.5V12h12zm0-5.5h-5V7h5z'/%3E%3C/svg%3E");
        background-color: currentColor;
        mask-image: var(--svg);
        mask-repeat: no-repeat;
        mask-size: 100% 100%;
    }
}

.module {
    details {
        em.coowners {
            display: inline-block;
            margin: 0 0 14px 0;
            font-size: 0.9rem;
            opacity: 0.5;
        }
    }
}

.answers > article {
    .question, .answer {
        display: flex;
        flex-direction: column;
        gap: var(--mar2);
        border-radius: $border-radius;
        padding: var(--pad1) 0 var(--pad1) var(--pad2);
    }

    .question {
        border-left: var(--pad2) solid #{$purple};
        margin-bottom: var(--mar2);
    }

    .answer {
        border-left: var(--pad2) solid #{$green};
    }

    padding-top: var(--mar3);
    margin-top: var(--mar3);
    border-top: 1px solid #8888;
}

.flashcard {
    border-left: var(--pad2) solid #{$amber-700};
    padding: var(--pad1) 0 var(--pad1) var(--pad2);
    border-radius: $border-radius;

    .correct {
        color: $green;
        font-weight: bold;
    }

    .incorrect {
        color: $purple;
        font-weight: bold;
    }

    &.daily {
        border-left: 0;
        padding-left: 0;
    }

    .wait {
        background-color: #8888;
        &::before {
            content: '';
            display: block;
            border-radius: 4px;
            height: 0.5em;
            background-color: $green;
        }
        &.incorrect::before {
            background-color: $purple;
        }
    }
}

.learning-resource-card {
    display: flex;
    box-shadow: var(--card-box-shadow);
    border: 1px solid var(--card-border-color);
    position: relative;

    .learning-resource-content {
        display: flex;
        flex-grow: 1;
        align-items: flex-start;

        .learning-resource-thumbnail {
            margin-right: var(--mar2);
            width: 100%;
            max-width: 150px;
            min-width: 100px;
            border-radius: 4px;
            aspect-ratio: 1;
            background-size: cover;
            background-position: center;
            flex-shrink: 0; /* Prevent thumbnail from shrinking */
        }

        .learning-resource-info {
            padding: var(--pad2);
            margin-bottom: 32px;
            flex: 1 1 0; /* Allow flex-grow and flex-shrink */
            min-width: 0; /* Prevent overflow issues */

            h1 {
                font-size: 100%;
                font-weight: bold;
                border: none;
                white-space: nowrap; /* Prevent line breaking */
                overflow: hidden;
                text-overflow: ellipsis;
            }

            p {
                color: var(--color);
            }
        }
    }
}

.feedback-container {
    position: absolute;
    bottom: 6px;
    right: 0px;
    display: flex;
    flex-direction: row;
    align-items: center;

    .feedback-button-container {
        display: flex;
        flex-direction: row;
        align-items: center;
        gap: var(--mar1);

        button {
            background: none;
            cursor: pointer;
            transition: transform 0.2s, color 0.2s;
            color: var(--color);
            padding: 0.5rem;

            &:hover {
                transform: scale(1.1);
            }

            &.clicked {
                &.like-button {
                    .feedback-svg {
                        fill: $green;
                    }
                }

                &.dislike-button {
                    .feedback-svg {
                        fill: $red-400;
                    }
                }
            }
        }

        .feedback-count {
            font-size: 1rem;
            color: var(--color);
            min-width: 2rem;
        }
    }
}

@media (max-width: 750px) {
    .learning-resource-thumbnail {
        display: none;
    }
}

.card > .ct-chart-donut {
    display: flex;
    justify-content: space-between;
    
    > svg {
        margin-top: -42px;
        max-width: 150px;
    }

    .ct-label {
        fill: white;
    }

    .flex-center {
        display: flex;
        align-items: center;
        padding: 4px;
    }

    .flex-row {
        display: flex;
        flex-direction: row;
    }

    .ct-donut-legend {
        display: flex;
        align-items: baseline;
    }

    .ct-donut-legend-label {
        margin-left: var(--pad1);
    }
    
    .ct-donut-legend:nth-child(1) .ct-donut-legend-color, .ct-series-a > * {
        fill: #009c82;
        background-color: #009c82;
    }

    .ct-donut-legend:nth-child(2) .ct-donut-legend-color, .ct-series-b > * {
        fill: #FFD502;
        background-color: #FFD502;
    }

    .ct-donut-legend:nth-child(3) .ct-donut-legend-color, .ct-series-c > * {
        fill: #db0651;
        background-color: #db0651;
    }
    
    .ct-donut-legend:nth-child(4) .ct-donut-legend-color, .ct-series-d > * {
        fill: #8882;
        background-color: #8882;
    }

    .ct-donut-legend .ct-donut-legend-color {
        width: 12px;
        height: 12px;
        border-radius: 2px;
    }
}
